diff --git a/jit/jit-cache.c b/jit/jit-cache.c
index 0f01485..cb176fa 100644
--- a/jit/jit-cache.c
+++ b/jit/jit-cache.c
@@ -32,6 +32,23 @@ See the bottom of this file for documentation on the cache system.
 extern	"C" {
 #endif
 
+/* #define RED_BLACK_DEBUG */
+/* #define RED_BLACK_DUMP */
+
+#ifdef RED_BLACK_DEBUG
+#define CHECKTREE(reason) RB_DEBUG(OutputDebugString(reason)); CheckLookupTreeValidity(cache)
+#else
+#define CHECKTREE(reason)
+#endif
+
+#ifdef RED_BLACK_DUMP
+#define RB_DEBUG(cmd) cmd
+#define DUMPLOOKUPTREE(dumpreason, highlight) DumpLookupTree(cache, dumpreason, highlight)
+#else
+#define RB_DEBUG(cmd)
+#define DUMPLOOKUPTREE(dumpreason, highlight)
+#endif
+
 /*
  * Tune the default size of a cache page.  Memory is allocated from
  * the system in chunks of this size.
@@ -71,11 +88,18 @@ struct jit_cache_method
 {
 	void			*method;	/* Method containing the region */
 	void			*cookie;	/* Cookie value for the region */
+	unsigned char		*allocated;	/* Allocated code memory for this method. */
 	unsigned char		*start;		/* Start of the region */
 	unsigned char		*end;		/* End of the region */
 	jit_cache_debug_t	debug;		/* Debug information for method */
-	jit_cache_method_t	left;		/* Left sub-tree and red/black bit */
-	jit_cache_method_t	right;		/* Right sub-tree */
+	union
+	{
+		jit_cache_method_t	link[2];
+		struct {
+			jit_cache_method_t	left;		/* Left sub-tree and red/black bit */
+			jit_cache_method_t	right;		/* Right sub-tree */
+		} lr;
+	};
 
 };
 
@@ -111,6 +135,12 @@ struct jit_cache
 	jit_cache_debug_t	firstDebug;	/* First debug block for method */
 	jit_cache_debug_t	lastDebug;	/* Last debug block for method */
 
+	/* plugable memmory management functions */
+	jit_malloc_code_func	malloc_code_func;
+	jit_resize_code_func	resize_code_func;
+	jit_free_code_func	free_code_func;
+	jit_malloc_func		malloc_func;
+	jit_free_func		free_func;
 };
 
 /*
@@ -382,24 +412,30 @@ static void AllocCachePage(jit_cache_t cache, int factor)
  * Get or set the sub-trees of a node.
  */
 #define	GetLeft(node)	\
-	((jit_cache_method_t)(((jit_nuint)((node)->left)) & ~((jit_nuint)1)))
-#define	GetRight(node)	((node)->right)
+	((jit_cache_method_t)(((jit_nuint)((node)->lr.left)) & ~((jit_nuint)1)))
+#define	GetRight(node)	((node)->lr.right)
 #define	SetLeft(node,value)	\
-	((node)->left = (jit_cache_method_t)(((jit_nuint)(value)) | \
-						(((jit_nuint)((node)->left)) & ((jit_nuint)1))))
+	((node)->lr.left = (jit_cache_method_t)(((jit_nuint)(value)) | \
+						(((jit_nuint)((node)->lr.left)) & ((jit_nuint)1))))
 #define	SetRight(node,value)	\
-			((node)->right = (value))
+			((node)->lr.right = (value))
+/* Code using indexed getters / setters can make use of the symetry of the tree algorithm. */
+#define GetIndex(node, index) \
+	((jit_cache_method_t)(((jit_nuint)((node)->link[index])) & ~((jit_nuint)1)))
+#define SetIndex(node, index, value) \
+	((node)->link[index] = (jit_cache_method_t)(((jit_nuint)(value)) | \
+						(((jit_nuint)((node)->link[index])) & ((jit_nuint)1))))
 
 /*
  * Get or set the red/black state of a node.
  */
 #define	GetRed(node)	\
-	((((jit_nuint)((node)->left)) & ((jit_nuint)1)) != 0)
+	((((jit_nuint)((node)->lr.left)) & ((jit_nuint)1)) != 0)
 #define	SetRed(node)	\
-	((node)->left = (jit_cache_method_t)(((jit_nuint)((node)->left)) | \
+	((node)->lr.left = (jit_cache_method_t)(((jit_nuint)((node)->lr.left)) | \
 									     ((jit_nuint)1)))
 #define	SetBlack(node)	\
-	((node)->left = (jit_cache_method_t)(((jit_nuint)((node)->left)) & \
+	((node)->lr.left = (jit_cache_method_t)(((jit_nuint)((node)->lr.left)) & \
 									    ~((jit_nuint)1)))
 
 /*
@@ -431,45 +467,171 @@ static int CacheCompare(jit_cache_t cache, unsigned char *key,
 	}
 }
 
+#ifdef RED_BLACK_DEBUG
+
+#include <stdio.h>
+
+void debugprintf(const unsigned char * format, ...)
+{
+	va_list argptr;
+	unsigned char buffer[1024];
+
+	va_start( argptr, format );
+	vsnprintf(buffer, sizeof(buffer)-1, format, argptr);
+	buffer[1023]='\0';
+	OutputDebugString(buffer);
+	va_end( argptr );
+}
 /*
- * Rotate a sub-tree around a specific node.
+ * Debug only: Check the validity of the red black tree.
  */
-static jit_cache_method_t CacheRotate(jit_cache_t cache, unsigned char *key,
-								      jit_cache_method_t around)
+int _CheckLookupTreeValidity_r(jit_cache_t cache, jit_cache_method_t node)
 {
-	jit_cache_method_t child, grandChild;
-	int setOnLeft;
-	if(CacheCompare(cache, key, around) < 0)
+	int lh;
+	int rh;
+	jit_cache_method_t nil = &(cache->nil);
+
+	if ( node == nil)
 	{
-		child = GetLeft(around);
-		setOnLeft = 1;
+		return 1;
 	}
-	else
+	else 
 	{
-		child = GetRight(around);
-		setOnLeft = 0;
+		jit_cache_method_t ln = GetLeft(node);
+		jit_cache_method_t rn = GetRight(node);
+
+		/* Consecutive red links */
+		if ( GetRed(node) ) 
+		{
+			if ( GetRed(ln) || GetRed(rn) ) 
+			{
+				OutputDebugString( "Red violation\n" );
+				return 0;
+			}
+		}
+
+		lh =  _CheckLookupTreeValidity_r(cache, ln);
+		rh =  _CheckLookupTreeValidity_r(cache, rn);
+
+		/* Invalid binary search tree */
+		if ( (ln != nil && CacheCompare(cache, node->start, ln) <= 0) || (rn != nil && CacheCompare(cache, node->start, rn) >= 0) )
+		{
+			OutputDebugString( "Binary tree violation\n" );
+			return 0;
+		}
+
+		/* Black height mismatch */
+		if ( lh != 0 && rh != 0 && lh != rh )
+		{
+			OutputDebugString("Black violation\n" );
+			return 0;
+		}
+
+		/* Only count black links */
+		if ( lh != 0 && rh != 0 )
+		{
+			return GetRed(node) ? lh : lh + 1;
+		}
+		else
+		{
+			return 0;
+		}
 	}
-	if(CacheCompare(cache, key, child) < 0)
+}
+
+void CheckLookupTreeValidity(jit_cache_t cache)
+{
+	int result;
+	
+	result = _CheckLookupTreeValidity_r(cache, GetRight(&cache->head));
+	if ( result )
 	{
-		grandChild = GetLeft(child);
-		SetLeft(child, GetRight(grandChild));
-		SetRight(grandChild, child);
+		RB_DEBUG(OutputDebugString("Tree OK.\n"));
 	}
 	else
 	{
-		grandChild = GetRight(child);
-		SetRight(child, GetLeft(grandChild));
-		SetLeft(grandChild, child);
+		DebugBreak();
+	}
+}
+
+/*
+ * Dump the lookup tree in a format that can be read by graphviz (http://www.graphviz.org)
+ */
+
+int dumpcount = 0;
+ 
+void _DumpLookupTree_r(jit_cache_t cache, jit_cache_method_t node, jit_cache_method_t highlight)
+{
+	jit_cache_method_t nil = &(cache->nil);
+
+	if ( node == nil)
+	{
+		return;
 	}
-	if(setOnLeft)
+	
+	jit_cache_method_t ln = GetLeft(node);
+	jit_cache_method_t rn = GetRight(node);
+
+	debugprintf("\t\tg%d%08lx [label = \"<f0> |<f1> %08lx|<f2> \"%s%s];\n", dumpcount, node->start, node->start,
+		GetRed(node) ? ", fillcolor=lightpink, style=filled" : "",
+		node == highlight ? ", color=red, penwidth=2" : ""
+	);
+	if ( ln != nil )
 	{
-		SetLeft(around, grandChild);
+		debugprintf("\t\tg%d%08lx:f0 -> g%d%08lx:f1 [color=%s%s];\n", dumpcount, node->start, dumpcount, ln->start, 
+			(node == highlight || ln == highlight) ? "red, penwidth=2" : "black",
+			GetRed(node) == GetRed(ln) ? ", minlen=2":"");
 	}
-	else
+	if ( rn != nil )
 	{
-		SetRight(around, grandChild);
+		debugprintf("\t\tg%d%08lx:f2 -> g%d%08lx:f1 [color=%s%s];\n", dumpcount, node->start, dumpcount, rn->start,
+			(node == highlight || rn == highlight) ? "red, penwidth=2" : "black",
+			GetRed(node) == GetRed(rn) ? ", minlen=2":""
+		);
 	}
-	return grandChild;
+	
+	_DumpLookupTree_r(cache, ln, highlight);
+	_DumpLookupTree_r(cache, rn, highlight);
+}
+
+void DumpLookupTree(jit_cache_t cache, char* dumpReason, jit_cache_method_t highlight)
+{
+	//debugprintf("DumpLookupTree, head = $%08lx, nil = $%08lx\n", &cache->head, &(cache->nil));
+	debugprintf("digraph G {\n");
+	debugprintf("\tgraph [dpi=100];\n");
+	debugprintf("\tnode [shape=record, fontsize=12, fontname=\"helvetica\"];\n");
+	debugprintf("\tsubgraph cluster%d\n\t{\n", dumpcount);
+	debugprintf("\t\tlabel=\"%s\"\n", dumpReason);
+	_DumpLookupTree_r(cache, GetRight(&cache->head), highlight);
+	debugprintf("\t}\n}\n", &cache->head, &(cache->nil));
+	dumpcount++;
+}
+
+#endif
+
+/*
+ * Rotate a sub-tree around a specific node.
+ */
+static jit_cache_method_t Rotate(jit_cache_method_t node, int dir)
+{
+	jit_cache_method_t save = GetIndex(node, !dir);
+	SetIndex(node, !dir, GetIndex(save, dir));
+	SetIndex(save, dir, node);
+	SetRed(node);
+	SetBlack(save);
+	return save;
+}
+ 
+static jit_cache_method_t CacheRotate(jit_cache_t cache, unsigned char *key,
+								      jit_cache_method_t around)
+{
+	jit_cache_method_t child, result;
+	int dir = CacheCompare(cache, key, around) > 0;
+
+	child = GetIndex(around, dir);
+	result = Rotate(child, CacheCompare(cache, key, child) < 0);
+	SetIndex(around, dir, result);
+	return result;
 }
 
 /*
@@ -544,8 +706,8 @@ static void AddToLookupTree(jit_cache_t cache, jit_cache_method_t method)
 	}
 
 	/* Insert the new node into the current position */
-	method->left = (jit_cache_method_t)(((jit_nuint)nil) | ((jit_nuint)1));
-	method->right = nil;
+	method->lr.left = (jit_cache_method_t)(((jit_nuint)nil) | ((jit_nuint)1));
+	method->lr.right = nil;
 	if(CacheCompare(cache, key, parent) < 0)
 	{
 		SetLeft(parent, method);
@@ -555,7 +717,134 @@ static void AddToLookupTree(jit_cache_t cache, jit_cache_method_t method)
 		SetRight(parent, method);
 	}
 	Split();
-	SetBlack(cache->head.right);
+	SetBlack(cache->head.lr.right);
+
+	CHECKTREE("After AddToLookupTree check... ");
+}
+
+/*
+ * Remove a method region block from the red-black lookup tree
+ * that is associated with a method cache.
+ * Algorithm loosely based on the information / code found at:
+ * http://www.eternallyconfuzzled.com/tuts/datastructures/jsw_tut_rbtree.aspx
+ */
+static void RemoveFromLookupTree(jit_cache_t cache, jit_cache_method_t method)
+{
+	unsigned char *key = method->start;
+	jit_cache_method_t temp;
+	jit_cache_method_t grandParent;
+	jit_cache_method_t parent;
+	jit_cache_method_t found = NULL;
+	jit_cache_method_t saved;
+	jit_cache_method_t nil = &(cache->nil);
+	int dir = 1;
+	int dir2;
+	int last;
+
+	temp = &(cache->head);
+	grandParent = temp;
+	parent = temp;
+	
+	/* Search while pushing a red node down our search path. */
+	RB_DEBUG(char dumpreason[64]; sprintf(dumpreason, "remove %08lx", (unsigned long)method->start));
+	DUMPLOOKUPTREE(dumpreason, method);
+	while( GetIndex(temp, dir) != nil)
+	{
+		/* Adjust our ancestor pointers */
+		grandParent = parent;
+		parent = temp;
+		temp = GetIndex(temp, dir);
+		last = dir;
+		dir = CacheCompare(cache, key, temp) > 0;
+
+		if(temp == method)
+		{
+			found = temp;
+		}
+
+		/* See if there's a red node in the direction we go. If not, push it down. */
+		if ( !GetRed(temp) && !GetRed( GetIndex(temp, dir) ) )
+		{
+			if ( GetRed( GetIndex(temp, !dir) ) )
+			{
+				RB_DEBUG(sprintf(dumpreason, "rotate under parent %08lx %d", (unsigned long)parent->start, dir));
+				SetIndex(parent, last, Rotate(temp, dir));
+				parent = GetIndex(parent, last);
+				DUMPLOOKUPTREE(dumpreason, parent);
+			}
+			else
+			{
+				saved = GetIndex(parent, !last);
+				if ( saved != nil )
+				{
+					if ( !GetRed(GetLeft(saved) ) && !GetRed(GetRight(saved)) )
+					{
+						/* Simply invert the colors */
+						SetBlack(parent);
+						SetRed(saved);
+						SetRed(temp);
+						DUMPLOOKUPTREE("swap colors", parent);
+					}
+					else
+					{
+						dir2 = GetRight(grandParent) == parent;
+
+						if ( GetRed(GetIndex(saved, last)) )
+						{
+							SetIndex(parent, !last, Rotate(GetIndex(parent, !last), !last));
+							RB_DEBUG(sprintf(dumpreason, "1) rotate under parent %08lx %d", (unsigned long)parent->start, last));
+							DUMPLOOKUPTREE(dumpreason, parent);
+							SetIndex(grandParent, dir2, Rotate(parent, last));
+							RB_DEBUG(sprintf(dumpreason, "2) rotate under grandparent %08lx %d", (unsigned long)grandParent->start, last));
+							DUMPLOOKUPTREE(dumpreason, grandParent);
+						}
+						else if ( GetRed(GetIndex(saved, !last)) )
+						{
+							SetIndex(grandParent, dir2, Rotate(parent, last));
+							RB_DEBUG(sprintf(dumpreason, "rotate under grandparent %08lx %d", (unsigned long)grandParent->start, last));
+							DUMPLOOKUPTREE(dumpreason, grandParent);
+						}
+
+						/* Make sure the coloring is correct */
+						SetRed(temp);
+						SetRed(GetIndex(grandParent, dir2));
+						SetBlack(GetLeft(GetIndex(grandParent, dir2)));
+						SetBlack(GetRight(GetIndex(grandParent, dir2)));
+						DUMPLOOKUPTREE("restore coloring", grandParent);
+					}
+				}
+			}
+			/* CHECKTREE("After 1 delete step..."); */
+		}
+	}
+
+	/* Do the actual switch & delete. */
+	if ( found != NULL ) 
+	{
+		if ( found != temp )
+		{
+			found->method = temp->method;
+			found->cookie = temp->cookie;
+			found->allocated = temp->allocated;
+			found->start = temp->start;
+			found->end = temp->end;
+			found->debug = temp->debug;
+		}
+		/* Give our parent the one and only link we had. */
+		SetIndex(parent,(GetRight(parent) == temp), GetIndex(temp, GetLeft(temp) == nil));
+		_jit_cache_free(cache, temp);
+	}
+	else
+	{
+		RB_DEBUG(debugprintf("RB node not found!\n"));
+		RB_DEBUG(DebugBreak(););
+	}
+
+	/* Make sure the root is black. */
+	SetBlack(GetRight(&cache->head));
+
+	DUMPLOOKUPTREE("Delete done", found);
+	CHECKTREE("After RemoveFromLookupTree check... ");
 }
 
 /*
@@ -565,7 +854,7 @@ static void FlushCacheDebug(jit_cache_posn *posn)
 {
 	jit_cache_t cache = posn->cache;
 	jit_cache_debug_t debug;
-
+	
 	/* Allocate a new jit_cache_debug structure to hold the data */
 	debug = _jit_cache_alloc(posn,
 		(unsigned long)(sizeof(struct jit_cache_debug) + cache->debugLen));
@@ -618,7 +907,15 @@ static void WriteCacheDebug(jit_cache_posn *posn, long offset, long nativeOffset
 	}
 }
 
-jit_cache_t _jit_cache_create(long limit, long cache_page_size, int max_page_factor)
+int _jit_cache_has_custom_allocator(jit_cache_t cache)
+{
+	return cache->malloc_code_func != 0;
+}
+
+jit_cache_t _jit_cache_create(long limit, long cache_page_size, int max_page_factor, 
+			      jit_malloc_code_func malloc_code_func, jit_resize_code_func resize_code_func, jit_free_code_func free_code_func,
+			      jit_malloc_func malloc_func, jit_free_func free_func
+			     )
 {
 	jit_cache_t cache;
 	unsigned long exec_page_size;
@@ -629,6 +926,13 @@ jit_cache_t _jit_cache_create(long limit, long cache_page_size, int max_page_fac
 		return 0;
 	}
 
+	/* Set optional external allocator callbacks. */
+	cache->malloc_code_func = malloc_code_func;
+	cache->resize_code_func	= resize_code_func;
+	cache->free_code_func	= free_code_func;
+	cache->malloc_func 	= malloc_func;
+	cache->free_func	= free_func;
+
 	/* determine the default cache page size */
 	exec_page_size = jit_exec_page_size();
 	if(cache_page_size <= 0)
@@ -676,26 +980,29 @@ jit_cache_t _jit_cache_create(long limit, long cache_page_size, int max_page_fac
 	cache->nil.start = 0;
 	cache->nil.end = 0;
 	cache->nil.debug = 0;
-	cache->nil.left = &(cache->nil);
-	cache->nil.right = &(cache->nil);
+	cache->nil.lr.left = &(cache->nil);
+	cache->nil.lr.right = &(cache->nil);
 	cache->head.method = 0;
 	cache->head.cookie = 0;
 	cache->head.start = 0;
 	cache->head.end = 0;
 	cache->head.debug = 0;
-	cache->head.left = 0;
-	cache->head.right = &(cache->nil);
+	cache->head.lr.left = &(cache->nil);;
+	cache->head.lr.right = &(cache->nil);
 	cache->start = 0;
 	cache->debugLen = 0;
 	cache->firstDebug = 0;
 	cache->lastDebug = 0;
 
-	/* Allocate the initial cache page */
-	AllocCachePage(cache, 0);
-	if(!cache->freeStart)
+	if ( !_jit_cache_has_custom_allocator(cache) )
 	{
-		_jit_cache_destroy(cache);
-		return 0;
+		/* Allocate the initial cache page */
+		AllocCachePage(cache, 0);
+		if(!cache->freeStart)
+		{
+			_jit_cache_destroy(cache);
+			return 0;
+		}
 	}
 
 	/* Ready to go */
@@ -737,18 +1044,42 @@ _jit_cache_check_space(jit_cache_posn *posn, int space)
 	}
 }
 
+_jit_cache_free_debug(jit_cache_t cache, jit_cache_debug_t debug)
+{
+	jit_cache_debug_t nextdebug;
+
+	while ( debug )
+	{
+		nextdebug = debug->next;
+		_jit_cache_free(cache, debug);
+		debug = nextdebug;
+	}
+}
+
 int _jit_cache_start_method(jit_cache_t cache,
 			    jit_cache_posn *posn,
 			    int page_factor,
 			    int align,
+			    unsigned long predicted_size,
 			    void *method)
 {
+	unsigned char *allocated = NULL;
 	unsigned char *ptr;
+	unsigned long actual_size;
 
-	/* Do we need to allocate a new cache page? */
-	if(page_factor > 0)
+	if ( _jit_cache_has_custom_allocator(cache) )
 	{
-		AllocCachePage(cache, page_factor);
+		allocated = (*cache->malloc_code_func)(predicted_size, &actual_size);
+		cache->freeStart = allocated;
+		cache->freeEnd = cache->freeStart + actual_size;
+	}
+	else
+	{	
+		/* Do we need to allocate a new cache page? */
+		if(page_factor > 0)
+		{
+			AllocCachePage(cache, page_factor);
+		}
 	}
 
 	/* Bail out if the cache is already full */
@@ -756,7 +1087,7 @@ int _jit_cache_start_method(jit_cache_t cache,
 	{
 		return JIT_CACHE_TOO_BIG;
 	}
-
+	
 	/* Set up the initial cache position */
 	posn->cache = cache;
 	posn->ptr = cache->freeStart;
@@ -791,11 +1122,12 @@ int _jit_cache_start_method(jit_cache_t cache,
 	}
 	cache->method->method = method;
 	cache->method->cookie = 0;
+	cache->method->allocated = allocated;
 	cache->method->start = posn->ptr;
 	cache->method->end = posn->ptr;
 	cache->method->debug = 0;
-	cache->method->left = 0;
-	cache->method->right = 0;
+	cache->method->lr.left = 0;
+	cache->method->lr.right = 0;
 
 	/* Store the method start address */
 	cache->start = posn->ptr;
@@ -814,25 +1146,44 @@ int _jit_cache_end_method(jit_cache_posn *posn)
 	jit_cache_method_t method;
 	jit_cache_method_t next;
 
+	method = cache->method;
+	
 	/* Determine if we ran out of space while writing the method */
 	if(posn->ptr >= posn->limit)
 	{
 		/* If we had a newly allocated page then it has to be freed
 		   to let allocate another new page of appropriate size. */
-		if((cache->freeStart == ((unsigned char *)(cache->pages[cache->numPages - 1].page)))
-		    && (cache->freeEnd
-			== (cache->freeStart + (cache->pageSize * cache->pages[cache->numPages - 1].factor))))
+		if ( _jit_cache_has_custom_allocator(cache) )
 		{
-			--(cache->numPages);
-			jit_free_exec(cache->pages[cache->numPages].page,
-				      cache->pageSize * cache->pages[cache->numPages].factor);
-			if (cache->pagesLeft >= 0)
+			_jit_cache_free_debug(cache, method->debug);
+			while ( method )
 			{
-				cache->pagesLeft += cache->pages[cache->numPages].factor;
+				_jit_cache_free_code(cache, method->allocated);
+				next = method->lr.right;
+				_jit_cache_free(cache, method);
+				method = next;
 			}
 			cache->freeStart = 0;
 			cache->freeEnd = 0;
 		}
+		else
+		{
+			if((cache->freeStart == ((unsigned char *)(cache->pages[cache->numPages - 1].page)))
+			    && (cache->freeEnd
+				== (cache->freeStart + (cache->pageSize * cache->pages[cache->numPages - 1].factor))))
+			{
+				--(cache->numPages);
+				jit_free_exec(cache->pages[cache->numPages].page,
+					      cache->pageSize * cache->pages[cache->numPages].factor);
+				if (cache->pagesLeft >= 0)
+				{
+					cache->pagesLeft += cache->pages[cache->numPages].factor;
+				}
+				cache->freeStart = 0;
+				cache->freeEnd = 0;
+			}
+		}
+		cache->method = 0;
 		return JIT_CACHE_RESTART;
 	}
 
@@ -847,19 +1198,27 @@ int _jit_cache_end_method(jit_cache_posn *posn)
 	}
 
 	/* Flush the position information back to the cache */
-	cache->freeStart = posn->ptr;
-	cache->freeEnd = posn->limit;
+	if ( _jit_cache_has_custom_allocator(cache) )
+	{
+		(*cache->resize_code_func)(cache->freeStart, posn->ptr - cache->freeStart);
+		cache->freeStart = 0;
+		cache->freeEnd = 0;
+	}
+	else
+	{
+		cache->freeStart = posn->ptr;
+		cache->freeEnd = posn->limit;
+	}
 
 	/* Update the last method region block and then
 	   add all method regions to the lookup tree */
-	method = cache->method;
 	if(method)
 	{
 		method->end = posn->ptr;
 		do
 		{
 			method->debug = cache->firstDebug;
-			next = method->right;
+			next = method->lr.right;
 			AddToLookupTree(cache, method);
 			method = next;
 		}
@@ -871,10 +1230,82 @@ int _jit_cache_end_method(jit_cache_posn *posn)
 	return JIT_CACHE_OK;
 }
 
+jit_cache_method_t _jit_cache_get_node(jit_cache_t cache, void *pc)
+{
+	jit_cache_method_t node = cache->head.lr.right;
+	while(node != &(cache->nil))
+	{
+		if(((unsigned char *)pc) < node->start)
+		{
+			node = GetLeft(node);
+		}
+		else if(((unsigned char *)pc) >= node->end)
+		{
+			node = GetRight(node);
+		}
+		else
+		{
+			return node;
+		}
+	}
+	return 0;
+}
+
+/* Initially, call with NULL method. The recursion will fill it. */
+void _jit_cache_free_method_r(jit_cache_t cache, void *entry_point, void* method)
+{
+	jit_cache_method_t node;
+
+	/* Check if we support freeing of methods. */
+	if ( !_jit_cache_has_custom_allocator(cache) )
+	{
+		return;
+	}
+
+	node = _jit_cache_get_node(cache, entry_point);
+	
+	if (node)
+	{
+		if ( method == NULL )
+		{
+			method = node->method;
+
+			/* First time, free the debug information */
+			_jit_cache_free_debug(cache, node->debug);
+		}
+
+		if ( method == node->method )
+		{
+			entry_point = node->end;
+
+			/* Free allocated code memory */
+			_jit_cache_free_code(cache, node->allocated);
+
+			/* Remove the node from the tree. This will also free the node. */
+			RemoveFromLookupTree(cache, node);
+
+			/* We are continues, so free the (optional) next parts of this method... */
+			_jit_cache_free_method_r(cache, entry_point, method);
+		}
+	}
+}
+
+void _jit_cache_free_method(jit_cache_t cache, void *entry_point)
+{
+	 _jit_cache_free_method_r(cache, entry_point, NULL);
+}
+
 void *_jit_cache_alloc(jit_cache_posn *posn, unsigned long size)
 {
+	jit_cache_t cache = posn->cache;
 	unsigned char *ptr;
 
+	/* Use the custom allocator, if provided. */
+	if ( _jit_cache_has_custom_allocator(cache) )
+	{
+		return (*cache->malloc_func)(size);
+	}
+	
 	/* Bail out if the request is too big to ever be satisfiable */
 	if(size > (unsigned long)(posn->limit - posn->ptr))
 	{
@@ -904,6 +1335,12 @@ void *_jit_cache_alloc_no_method
 {
 	unsigned char *ptr;
 
+	/* Use the custom allocator, if provided. */
+	if ( _jit_cache_has_custom_allocator(cache) )
+	{
+		return (*cache->malloc_func)(size);
+	}
+	
 	/* Bail out if the request is too big to ever be satisfiable */
 	if(size > (unsigned long)(cache->freeEnd - cache->freeStart))
 	{
@@ -930,6 +1367,40 @@ void *_jit_cache_alloc_no_method
 	return (void *)ptr;
 }
 
+void _jit_cache_free(jit_cache_t cache, void *data)
+{
+	/* Only in case of an external allocator. We don't free. */
+	if ( _jit_cache_has_custom_allocator(cache) )
+	{
+		(*cache->free_func)(data);
+	}
+}
+
+void *_jit_cache_alloc_code(jit_cache_t cache, unsigned long size)
+{
+	unsigned long realsize;
+	void* result;
+	if ( _jit_cache_has_custom_allocator(cache) )
+	{
+		result = (*cache->malloc_code_func)(size, &realsize);
+		(*cache->resize_code_func)(result, size);
+		return result;
+	}
+	else
+	{
+		return _jit_cache_alloc_no_method(cache, size, 1);
+	}
+}
+
+void _jit_cache_free_code(jit_cache_t cache, void *data)
+{
+	/* Only in case of an external allocator. We don't free. */
+	if ( _jit_cache_has_custom_allocator(cache) )
+	{
+		(*cache->free_code_func)(data);
+	}
+}
+
 void _jit_cache_align(jit_cache_posn *posn, int align, int diff, int nop)
 {
 	jit_nuint current;
@@ -1005,12 +1476,13 @@ void _jit_cache_new_region(jit_cache_posn *posn, void *cookie)
 	}
 	newMethod->method = method->method;
 	newMethod->cookie = cookie;
+	newMethod->allocated = NULL;
 	newMethod->start = posn->ptr;
 	newMethod->end = posn->ptr;
 
 	/* Attach the new region to the cache */
-	newMethod->left = 0;
-	newMethod->right = method;
+	newMethod->lr.left = 0;
+	newMethod->lr.right = method;
 	posn->cache->method = newMethod;
 }
 
@@ -1024,25 +1496,14 @@ void _jit_cache_set_cookie(jit_cache_posn *posn, void *cookie)
 
 void *_jit_cache_get_method(jit_cache_t cache, void *pc, void **cookie)
 {
-	jit_cache_method_t node = cache->head.right;
-	while(node != &(cache->nil))
+	jit_cache_method_t node = _jit_cache_get_node(cache, pc);
+	if (node)
 	{
-		if(((unsigned char *)pc) < node->start)
-		{
-			node = GetLeft(node);
-		}
-		else if(((unsigned char *)pc) >= node->end)
+		if(cookie)
 		{
-			node = GetRight(node);
-		}
-		else
-		{
-			if(cookie)
-			{
-				*cookie = node->cookie;
-			}
-			return node->method;
+			*cookie = node->cookie;
 		}
+		return node->method;
 	}
 	return 0;
 }
@@ -1088,21 +1549,10 @@ static int add_parent(jit_cache_method_t *parent_buf,
 void *_jit_cache_get_start_method(jit_cache_t cache, void *pc)
 {
 	/* TODO: This function is not currently aware of multiple regions. */
-	jit_cache_method_t node = cache->head.right;
-	while(node != &(cache->nil))
+	jit_cache_method_t node = _jit_cache_get_node(cache, pc);
+	if (node)
 	{
-		if(((unsigned char *)pc) < node->start)
-		{
-			node = GetLeft(node);
-		}
-		else if(((unsigned char *)pc) >= node->end)
-		{
-			node = GetRight(node);
-		}
-		else
-		{
-			return node->start;
-		}
+		return node->start;
 	}
 	return 0;
 }
@@ -1113,7 +1563,7 @@ void *_jit_cache_get_end_method(jit_cache_t cache, void *pc)
 	jit_cache_method_t *parents = parent_buf;
 	int num_parents = 0;
 	int max_parents = 16;
-	jit_cache_method_t node = cache->head.right;
+	jit_cache_method_t node = cache->head.lr.right;
 	jit_cache_method_t last;
 	jit_cache_method_t parent;
 	void *method;
@@ -1280,7 +1730,7 @@ void **_jit_cache_get_method_list(jit_cache_t cache)
 
 	/* Count the number of distinct methods in the tree */
 	prev = 0;
-	num = CountMethods(cache->head.right, &(cache->nil), &prev);
+	num = CountMethods(cache->head.lr.right, &(cache->nil), &prev);
 
 	/* Allocate a list to hold all of the method descriptors */
 	list = (void **)jit_malloc((num + 1) * sizeof(void *));
@@ -1291,7 +1741,7 @@ void **_jit_cache_get_method_list(jit_cache_t cache)
 
 	/* Fill the list with methods and then return it */
 	prev = 0;
-	FillMethodList(list, cache->head.right, &(cache->nil), &prev);
+	FillMethodList(list, cache->head.lr.right, &(cache->nil), &prev);
 	list[num] = 0;
 	return list;
 }
@@ -1312,7 +1762,7 @@ typedef struct
 static void InitDebugIter(jit_cache_debug_iter *iter,
 						  jit_cache_t cache, void *start)
 {
-	jit_cache_method_t node = cache->head.right;
+	jit_cache_method_t node = cache->head.lr.right;
 	while(node != &(cache->nil))
 	{
 		if(((unsigned char *)start) < node->start)
diff --git a/jit/jit-cache.h b/jit/jit-cache.h
index e0c5dab..0b00b45 100644
--- a/jit/jit-cache.h
+++ b/jit/jit-cache.h
@@ -54,7 +54,10 @@ typedef struct
  */
 jit_cache_t _jit_cache_create(long limit,
 			      long cache_page_size,
-			      int max_page_factor);
+			      int max_page_factor,
+			      jit_malloc_code_func malloc_code_func, jit_resize_code_func resize_code_func, jit_free_code_func free_code_func,
+			      jit_malloc_func malloc_func, jit_free_func free_func
+);
 
 /*
  * Destroy a method cache.
@@ -96,7 +99,8 @@ int _jit_cache_start_method(jit_cache_t cache,
 			    jit_cache_posn *posn,
 			    int page_factor,
 			    int align,
-			    void *cookie);
+			    unsigned long predicted_size,
+			    void *method);
 
 /*
  * End output of a method.  Returns zero if a restart.
@@ -104,6 +108,11 @@ int _jit_cache_start_method(jit_cache_t cache,
 int _jit_cache_end_method(jit_cache_posn *posn);
 
 /*
+ * Free all resources known by the cache, associated with this method.
+ */
+void _jit_cache_free_method(jit_cache_t cache, void *entry_point);
+
+/*
  * Allocate "size" bytes of storage in the method cache's
  * auxillary data area.  Returns NULL if insufficient space
  * to satisfy the request.  It may be possible to satisfy
@@ -118,6 +127,11 @@ void *_jit_cache_alloc(jit_cache_posn *posn, unsigned long size);
 void *_jit_cache_alloc_no_method
 	(jit_cache_t cache, unsigned long size, unsigned long align);
 
+void _jit_cache_free(jit_cache_t cache, void *data);
+
+void *_jit_cache_alloc_code(jit_cache_t cache, unsigned long size);
+void _jit_cache_free_code(jit_cache_t cache, void *data);
+	
 /*
  * Align the method code on a particular boundary if the
  * difference between the current position and the aligned
diff --git a/jit/jit-compile.c b/jit/jit-compile.c
index 8910912..7cf2bcf 100644
--- a/jit/jit-compile.c
+++ b/jit/jit-compile.c
@@ -42,6 +42,8 @@ typedef struct
 
 	int			restart;
 	int			page_factor;
+	int 			code_factor;
+	jit_nint		block_count;
 
 	void			*code_start;
 	void			*code_end;
@@ -404,21 +406,38 @@ cache_release(_jit_compile_t *state)
 static void
 cache_alloc(_jit_compile_t *state)
 {
+	jit_block_t block;
 	int result;
+	
+	if ( state->code_factor != 0 && state->block_count == 0 )
+	{
+		for(block = 0; (block = jit_block_next(state->func, block)) != 0; state->block_count++ );
+	}
 
 	/* First try with the current cache page */
 	result = _jit_cache_start_method(state->cache,
 					 &state->gen.posn,
 					 state->page_factor++,
 					 JIT_FUNCTION_ALIGNMENT,
+#ifdef JIT_PROLOG_SIZE
+					 state->block_count * state->code_factor + JIT_PROLOG_SIZE + 32,
+#else
+					 state->block_count * state->code_factor + 32,
+#endif
 					 state->func);
 	if(result == JIT_CACHE_RESTART)
 	{
 		/* No space left on the current cache page.  Allocate a new one. */
+		if ( state->code_factor ) state->code_factor += 3;
 		result = _jit_cache_start_method(state->cache,
 						 &state->gen.posn,
 						 state->page_factor++,
 						 JIT_FUNCTION_ALIGNMENT,
+#ifdef JIT_PROLOG_SIZE
+						 state->block_count * state->code_factor + JIT_PROLOG_SIZE + 32,
+#else
+						 state->block_count * state->code_factor + 32,
+#endif
 						 state->func);
 	}
 	if(result != JIT_CACHE_OK)
@@ -502,11 +521,17 @@ cache_realloc(_jit_compile_t *state)
 	cache_abort(state);
 
 	/* Allocate a new cache page with the size that grows
-	   by factor of 2 on each reallocation */
+	   by factor of 2 on each reallocation or with a 3-byte factor for custom allocation. */
+	if ( state->code_factor ) state->code_factor += 3;
 	result = _jit_cache_start_method(state->cache,
 					 &state->gen.posn,
 					 state->page_factor,
 					 JIT_FUNCTION_ALIGNMENT,
+#ifdef JIT_PROLOG_SIZE
+					 state->block_count * state->code_factor + JIT_PROLOG_SIZE + 32,
+#else
+					 state->block_count * state->code_factor + 32,
+#endif
 					 state->func);
 	if(result != JIT_CACHE_OK)
 	{
@@ -628,6 +653,7 @@ compile(_jit_compile_t *state, jit_function_t func)
 	/* Initialize compilation state */
 	jit_memzero(state, sizeof(_jit_compile_t));
 	state->func = func;
+	state->code_factor = jit_context_get_code_factor(func->context);
 
 	/* Replace user's exception handler with internal handler */
 	handler = jit_exception_set_handler(internal_exception_handler);
@@ -706,6 +732,11 @@ compile(_jit_compile_t *state, jit_function_t func)
 	jit_extra_gen_cleanup(&state->gen);
 #endif
 
+	if ( state->code_factor != 0 )
+	{
+		jit_context_update_code_factor(func->context, (state->code_end - state->code_start) / state->block_count + 1);
+	}
+	
 	/* End the function's output process */
 	cache_flush(state);
 
